package com.app.sounds.prank.party.act;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.view.View;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;

import com.app.sounds.prank.party.R;
import com.app.sounds.prank.party.bean.Info;
import com.app.sounds.prank.party.common.Utils;
import com.app.sounds.prank.party.common.Db;
import com.app.sounds.prank.party.common.ItemSpace;
import com.app.sounds.prank.party.databinding.PlayActivityBinding;
import com.app.sounds.prank.party.list.AdaInfo;
import com.app.sounds.prank.party.mylistener.ClickPrankListener;
import com.app.sounds.prank.party.mylistener.OnTimerListener;
import com.app.sounds.prank.party.top.AdManager;
import com.app.sounds.prank.party.top.onActionListener;
import com.bumptech.glide.Glide;

import java.io.IOException;
import java.util.List;

public class PlayActivity extends AppCompatActivity implements View.OnClickListener, OnTimerListener, ClickPrankListener {

    private PlayActivityBinding playBinding;

    private Info info;
    private PopupTimer popupTimer;

    private MediaPlayer mediaPlayer;
    private BroadcastReceiver volumeReceiver;
    private CountDownTimer countDownTimer;
    private int color;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        AdManager.loadAllAd();
        playBinding = PlayActivityBinding.inflate(getLayoutInflater());
        setContentView(playBinding.getRoot());
        Utils.setStatusBarTextColor(this, true);
        info = (Info) getIntent().getSerializableExtra(Utils.KEY_PLAY_DATA);
        color =  getIntent().getIntExtra(Utils.KEY_LIST_COLOR_POS,0);
//        playBinding.constraintLayout.setBackground(ContextCompat.getDrawable(this, Tools.playBgs[color]));
        initAudio();
        String covert = info.getCovert();
        if (covert != null && !covert.isEmpty()) {
            Glide.with(this).load(covert)
                    .placeholder(R.drawable.default_sounds)
                    .into(playBinding.image);
        } else {
            Glide.with(this).load(R.drawable.default_sounds)
                    .into(playBinding.image);
        }
        playBinding.name.setText(info.getName());
        playBinding.back.setOnClickListener(this);
        playBinding.btnPlay.setOnClickListener(this);
        playBinding.imLike.setOnClickListener(this);
        playBinding.imLoop.setOnClickListener(this);
        playBinding.imTimer.setOnClickListener(this);
        Utils.setVolume(this, playBinding.seekbar);

        initLike();
        loadMore();
        volumeReceiver();
        AdManager.showTopOn(PlayActivity.this, new onActionListener() {
            @Override
            public void onAction() {

            }
        });
    }

    private void stopCountDown() {
        if (countDownTimer != null) {
            countDownTimer.cancel();
        }
    }
    private void startCountDown(long time) {
        stopCountDown();
        countDownTimer = new CountDownTimer(time, 1000) {
            @Override
            public void onTick(long millisUntilFinished) {
            }
            @Override
            public void onFinish() {
                popupTimer.setOffSelected();
                if (!mediaPlayer.isPlaying()) {
                    playBinding.btnPlay.setSelected(true);
                    mediaPlayer.start();
                }
            }
        };
        countDownTimer.start();
    }
    private void volumeReceiver() {
        volumeReceiver = new BroadcastReceiver() {
            @Override
            public void onReceive(Context context, Intent intent) {
                if (intent.getAction().equals("android.media.VOLUME_CHANGED_ACTION")) {
                    AudioManager audioManager = (AudioManager) context.getSystemService(Context.AUDIO_SERVICE);
                    int currentVolume = audioManager.getStreamVolume(AudioManager.STREAM_MUSIC);
                    if (playBinding.seekbar.getProgress() != currentVolume) {
                        playBinding.seekbar.setProgress(currentVolume);
                    }

                }
            }
        };
        IntentFilter filter = new IntentFilter("android.media.VOLUME_CHANGED_ACTION");
        registerReceiver(volumeReceiver, filter);
    }
    private void initLike() {
        boolean b = Db.checkLike(info);
        playBinding.imLike.setSelected(b);
    }
    private void loadMore() {
        List<Info> more = Db.getMore();
        ItemSpace itemHelper = new ItemSpace(0, 0, (int) Utils.dpToPx(3));
        AdaInfo adaInfo = new AdaInfo(this, more, 1, this);
        playBinding.moreRecycler.setLayoutManager(new LinearLayoutManager(this, LinearLayoutManager.HORIZONTAL, false));
        playBinding.moreRecycler.setAdapter(adaInfo);
        playBinding.moreRecycler.addItemDecoration(itemHelper);
        adaInfo.setColorIndex(color);
    }

    private void initAudio() {
        showPlayBtn(false);
        mediaPlayer = new MediaPlayer();
        try {
            mediaPlayer.reset();
            mediaPlayer.setDataSource(info.getAudioUrl());
            mediaPlayer.prepareAsync();
            mediaPlayer.setOnPreparedListener(new MediaPlayer.OnPreparedListener() {
                @Override
                public void onPrepared(MediaPlayer mp) {
                    showPlayBtn(true);
                }
            });

            mediaPlayer.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
                @Override
                public void onCompletion(MediaPlayer mp) {
                    playBinding.btnPlay.setSelected(false);
                }
            });
        } catch (IOException ioException) {
            showPlayBtn(true);
        }
    }

    private void showPlayBtn(boolean showBtn) {
        if (showBtn) {
            playBinding.btnPlay.setVisibility(View.VISIBLE);
            playBinding.playLoading.setVisibility(View.GONE);
        } else {
            playBinding.btnPlay.setVisibility(View.GONE);
            playBinding.playLoading.setVisibility(View.VISIBLE);
        }
    }


    @Override
    public void onClick(View v) {
        if (v.equals(playBinding.back)) {
            finish();
        } else if (v.equals(playBinding.btnPlay)) {

            AdManager.showTopOn(PlayActivity.this, new onActionListener() {
                @Override
                public void onAction() {
                    boolean selected = playBinding.btnPlay.isSelected();
                    if (selected) {
                        if (mediaPlayer.isPlaying()) {
                            mediaPlayer.pause();
                        }
                    } else {
                        if (!mediaPlayer.isPlaying()) {
                            mediaPlayer.start();
                        }
                    }
                    playBinding.btnPlay.setSelected(!selected);
                }
            });



        } else if (v.equals(playBinding.imLike)) {
            playBinding.imLike.setSelected(!playBinding.imLike.isSelected());
            boolean selected = playBinding.imLike.isSelected();
            if (selected) {
                info.setColorIndex(color);
                Db.addLike(info);
            } else {
                Db.removeLike(info);
            }
        } else if (v.equals(playBinding.imLoop)) {
            playBinding.imLoop.setSelected(!playBinding.imLoop.isSelected());
            mediaPlayer.setLooping(playBinding.imLoop.isSelected());
        } else if (v.equals(playBinding.imTimer)) {
            AdManager.showTopOn(PlayActivity.this, new onActionListener() {
                @Override
                public void onAction() {
                    if (popupTimer == null) {
                        popupTimer = new PopupTimer(PlayActivity.this, PlayActivity.this);
                    }
                    popupTimer.showTop(playBinding.imTimer);
                }
            });

        }

    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (mediaPlayer.isPlaying()) {
            mediaPlayer.stop();
        }
        mediaPlayer.release();
        mediaPlayer = null;
        stopCountDown();
    }

    @Override
    public void onClickTimerListener(long time) {
        popupTimer.hide();
        if (time == -1) {
            stopCountDown();
        } else {
            startCountDown(time);
        }

    }

    @Override
    public void onClickSoundsListener(Info data) {
        Intent intent = new Intent(this, PlayActivity.class);
        intent.putExtra(Utils.KEY_PLAY_DATA, data);
        startActivity(intent);
        finish();
    }
}